function OUTIMG=enhancement_demo_CRC;

% Demonstration of image enhancement methods
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Call OUTIMG=enhancement_demo;

r=1;
while r==1,
m0=menu('Select image','Chest X-ray','Angiogram','MRI-brain','MRI-heart','MRI-head','Mammogram','Airphotograph','Space image','Crystals');
switch m0,
    case 1,load chest; INPIMG=chest;
    case 2,load ango; INPIMG=ango;
    case 3,load mri_15; INPIMG=mri_15;
    case 4, load heart; INPIMG=heart;
    case 5, load mri_16; INPIMG=mri_16;
    case 6; load mam; INPIMG=mam;
    case 7, load jerus;INPIMG=jerus;
    case 8, load Venera9; INPIMG=Venera9;
    case 9, load alumn;INPIMG=alumn;
end
m1=menu('Select method','Unsharp masking: mean','Unsharp masking: median','Global Histogram P-equalization',....
    'Local histogram P-equalizaion','Segmentation: EVnbh smoothing','Mode-ES smoothing','Edge extraction: Max-Min','Edge extraction: SizeEV','Edge extraction: Local Cardinality');
switch m1,
case 1,
    fig_n(2);
    figure(1);
    image(INPIMG);axis image;axis off
    title('Input image','FontWeight','Bold');
    [SzX,SzY]=size(INPIMG);
    WSZ=[3,5,7,15,25,45];
    s=1;
    while s==1,
    WSz=menu('Select window size','3x3','5x5','7x7','15x15','25x25','45,45');
    Lx=(WSZ(WSz)-1)/2;
    Ly=(WSZ(WSz)-1)/2;
    INPIMG_ext=img_ext(INPIMG,Lx,Ly);
    INPIMG_smth=conv2(INPIMG_ext,ones(WSZ(WSz))/(WSZ(WSz))^2,'same');
    imshow(INPIMG,[]);
    title('Input image','FontWeight','Bold');
    OUTIMG=(INPIMG-INPIMG_smth(Lx+1:Lx+SzX,Ly+1:Ly+SzY));
    figure(2);
    OUTIMG=disp_norm(OUTIMG,6);
    title(['Unsharp masking (Mean); WSz=',num2str(WSZ(WSz))],'FontWeight','Bold');
    s=menu('Other window size?','Yes','No');
    end
case 2,
    fig_n(2);
    figure(1);
    image(INPIMG);axis image;axis off
    title('Input image','FontWeight','Bold');
    [SzX,SzY]=size(INPIMG);
    WSZ=[3,5,7,15,25,45];
    s=1;
    while s==1,
    WSz=menu('Select window size','3x3','5x5','7x7','15x15','25x25','45,45');
    Lx=(WSZ(WSz)-1)/2;
    Ly=(WSZ(WSz)-1)/2;
    INPIMG_ext=img_ext(INPIMG,Lx,Ly);
    INPIMG_smth=lc_medn(INPIMG_ext,WSZ(WSz),WSZ(WSz),1);
    imshow(INPIMG,[]);
    title('Input image','FontWeight','Bold');
    OUTIMG=(INPIMG-INPIMG_smth(Lx+1:Lx+SzX,Ly+1:Ly+SzY));
    figure(2);
    OUTIMG=disp_norm(OUTIMG,6);
    title(['Unsharp masking (Median); WSz=',num2str(WSZ(WSz))],'FontWeight','Bold');
    s=menu('Other window size?','Yes','No');
    end
case 3,
    s=1;
    while s==1,
    P=menu('Select histogramp-equalization index P','0.1','0.2','0.3','0.4','0.5','0.6','0.7','0.8','0.9','1');
    OUTIMG=p_histequ(INPIMG,0.1*P);
    title(['P-Histogram equalization; P=',num2str(0.1*P)],'FontWeight','Bold');
    s=menu('Other P?','Yes','No');
    end
case 4,
    s=1;
    while s==1,
        P=menu('Select P','0.1','0.2','0.3','0.4','0.5','0.6','0.7','0.8','0.9','1');
        WSZ=[1,2,3,7,12,22];
        ss=1;
        while ss==1
        Lx=menu('Select window size','3x3','5x5','7x7','15x15','25x25','45,45');
        Lx=WSZ(Lx);
        OUTIMG=lcp_hsteq(INPIMG,Lx,Lx,0.1*P);
        ss=menu('Other window size?','Yes','No');
        end
        s=menu('Other P?','Yes','No');
    end
case 5,
    fig_n(2);
    WSz=menu('EV-NBH smoothing; select window size','3','5','7','9','11','13','15','17','19','21','23','25');
    EVplus=menu('EV-NBH smoothing; select EVplus','3','5','7','9','11','13','15','17','19','21','23','25');
    EVplus=2*EVplus+1;
    EVminus=menu('EV-NBH smoothing; select EVminus','3','5','7','9','11','13','15','17','19','21','23','25');
    EVminus=2*EVminus+1;
    figure(1);
    image(INPIMG);axis image;axis off;
    title('Input image','FontWeight','Bold')
    OUTIMG=INPIMG;
    figure(2);
    Iter=1;
    while Iter==1,
        OUTIMG=meanEV(OUTIMG,WSz,WSz,EVplus,EVminus);
        Iter=menu('Other iteration?','Yes','No');
    end
case 6,
    fig_n(2);
    WSz=menu('Mode-ES smoothing; select window size','3','5','7','9','11','13','15','17','19','21','23','25');
    figure(1);
    image(INPIMG);axis image;axis off;
    title('Input image','FontWeight','Bold')
    OUTIMG=INPIMG;
    figure(2);
    Iter=1;
    while Iter==1,
        OUTIMG=modeES(OUTIMG,WSz,WSz);
        Iter=menu('Other iteration?','Yes','No');
    end
case 7,
    fig_n(2);
    WSz=menu('MaxES-MinES; select window size','3','5','7','9','11','13','15','17','19','21','23','25');
    Lx=WSz;
    Ly=Lx;
    figure(1);
    image(INPIMG);axis image;axis off;
    title('Input image','FontWeight','Bold')
    OUTIMG=INPIMG;
    figure(2);
    Iter=1;
    while Iter==1,
        OUTIMG=max_mines(INPIMG,Lx,Ly);
        Iter=menu('Other iteration?','Yes','No');
    end
case 8
    fig_n(2);
    w=1;
    while w==1,
        WSz=menu('SizeEV: select window size','3','5','7','9','11','13','15','17','19','21','23','25');
        EVplus=menu('SizeEV: select EVplus','1','3','5','7','9','11','13','15','17','19','21','23','25');
        EVplus=2*EVplus-1;
        EVminus=menu('SizeEV: select EVminus','1','3','5','7','9','11','13','15','17','19','21','23','25');
        EVminus=2*EVminus-1;
        figure(1);
        imshow(INPIMG,[]);
        title('Input image','FontWeight','Bold')
        figure(2);
        OUTIMG=sizeEV(INPIMG,WSz,WSz,EVplus,EVminus);
        imshow(OUTIMG,[]);
        title(['SizeEV; WSz=',num2str(2*WSz+1),'x',num2str(2*WSz+1),'; EVplus=',num2str(EVplus),' ;EVminus=',num2str(EVminus)],'FontWeight','Bold')
        w=menu('Other window parameters?','Yes','No');
    end
case 9,
    fig_n(2);
    w=1;
    while w==1,
        WSz=menu('SizeEV: select window size','3','5','7','9','11','13','15','17','19','21','23','25');
        figure(1);
        imshow(INPIMG,[]);
        title('Input image','FontWeight','Bold')
        figure(2);
        OUTIMG=lc_cardinality(INPIMG,WSz,WSz);
        imshow(OUTIMG,[]);
        title(['LocCardinality; WSz=',num2str(2*WSz+1),'x',num2str(2*WSz+1)],'FontWeight','Bold')
        w=menu('Other window parameters?','Yes','No');
    end
end

r=menu('Continue','Yes','No');
end

%------------------------------------------------------------------------------------
function OUTIMG=p_histequ(INPIMG,P);

% Image histogram p-equalization
% For negative P, uses smoothed histogram
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call  OUTIMG=p_histequ(INPIMG,P);
 
fig_n(4);
figure(1);
myimage(INPIMG);title('Initial image','FontWeight','Bold');drawnow

[SzX SzY]=size(INPIMG);
mask=[1 1 1 1 1];
histbuf=zeros(256,SzY);
for n=1:SzX
buf=INPIMG(n,:); buf=buf+256*([0:SzY-1]);
histbuf(buf+1)=histbuf(buf+1)+ones(1,SzY);
end

h=sum(histbuf'); 
figure(2);
plot(h,'LineWidth',2);axis tight; grid;
title('Image histogram','FontWeight','Bold');
set(gca,'FontWeight','Bold');
drawnow

if P>=0, hp=h.^P; 
	else h=conv2(h,mask,'same');
	hp=h.^(-P); hp=hp.^(-1); end	

lut=cumsum(hp);	lut=round(255*lut/max(lut));
figure(4);
plot(lut,'LineWidth',2);axis tight;grid
title(['Transformation LUT, P=',num2str(P)],'FontWeight','Bold');
set(gca,'FontWeight','Bold');
drawnow;
OUTIMG=lutable(INPIMG,lut);
figure(3);
myimage(OUTIMG);
title(['P-equalized image, P=',num2str(P)],'FontWeight','Bold');
%----------------------------------------------------------------------------
function OUTIMG=lcp_hsteq(INPIMG,Lx,Ly,P);

% P-equalization of running histograms 
% Image mirror extention by the size of the spatial window
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call  OUTIMG=lcp_hsteq(INPIMG,Window Size X,Window Size Y,P);

fig_n(2);
figure(1);
display_1(INPIMG);
title('Input image','FontWeight','Bold');
drawnow
LX=2*Lx+1;LY=2*Ly+1;
[SzX SzY]=size(INPIMG);
figure(2);
OUTIMG=INPIMG;
display_1(OUTIMG);
drawnow

imgext=img_ext(INPIMG,Lx,Ly);
histbuf=zeros(256,SzY+2*Ly);

%Column histograms for the first row
for n=1:2*Lx+1,
	buf=imgext(n,:); buf=buf+256*([0:SzY+2*Ly-1]);
	histbuf(buf+1)=histbuf(buf+1)+ones(1,SzY+2*Ly);
end

%FIRST HISTOGRAM IN THE FIRST ROW
	
h=sum(histbuf(:,1:2*Ly+1)')'; 
hp=h.^P; hp=hp/sum(hp); 

centrpix=INPIMG(1,1);
OUTIMG(1,1)=255*(sum(hp(1:centrpix)));

% HISTOGRAMS FOR THE REST OF PIXELS IN THE ROW
for y=2:SzY,
	frgmhist=h;
	h=h-histbuf(:,y-1)+histbuf(:,y+LY-1);
	hp=h.^P; hp=hp/sum(hp); centrpix=INPIMG(1,y); 
	OUTIMG(1,y)=255*(sum(hp(1:centrpix)));
end

%COLUMN HISTOGRAMS FOR THE REST OF IMAGE

for x=2:SzX,
	buf=imgext(x-1,:); buf=buf+256*([0:SzY+2*Ly-1]);
	histbuf(buf+1)=histbuf(buf+1)-ones(1,SzY+2*Ly);
	buf=imgext(2*Lx+1+x-1,:); buf=buf+256*([0:SzY+2*Ly-1]);
	histbuf(buf+1)=histbuf(buf+1)+ones(1,SzY+2*Ly);

%FIRST HISTOGRAM IN THE Xth ROW
	h=sum(histbuf(:,1:2*Ly+1)')';
	hp=h.^P; hp=hp/sum(hp); centrpix=INPIMG(2,y); 
	OUTIMG(2,y)=255*(sum(hp(1:centrpix)));
	
%HISTOGRAMS FOR THE REST OF PIXELS IN THE Xth ROW			
	for y=2:SzY,
	frgmhist=h;
	h=h-histbuf(:,y-1)+histbuf(:,y+LY-1);
	hp=h.^P; hp=hp/sum(hp); centrpix=INPIMG(x,y); 
	OUTIMG(x,y)=255*(sum(hp(1:centrpix)));
	end
   if x/16-fix(x/16)==0,
      display_1(OUTIMG);
      title(['Local histogram P-equalization, P=',num2str(P),'; WSzX=',num2str(LX),'; WSzY=',num2str(LY)],'FontWeight','Bold');drawnow
   end
end
display_1(OUTIMG);
title(['Local histogram P-equalization, P=',num2str(P),'; WSzX=',num2str(LX),'; WSzY=',num2str(LY)],'FontWeight','Bold');drawnow

%-----------------------------------------------------------------------------
%------------------------------------------------------------------------------------------
function fig_n(N)
% Generating N square figure windows of ScreenVerSz/2*ScreenVerSz pixels
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Version July 15, 2001
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call figure_n(N)

% Generating a figure window
ScrSz=get(0,'ScreenSize');
HorSz=(ScrSz(3)-20); VerSz=(ScrSz(4));
close all;

switch N;
case 1, 
   Nvert=1;Nhor=1;H_Sz=(HorSz-80); V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-V_Sz V_Sz V_Sz]); colormap(gray(256))
case 2, 
   Nvert=1;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
case 3, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 4, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 5,
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 6, 
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-75-2*V_Sz H_Sz V_Sz]);colormap(gray(256))
end
%-------------------------------------------------------------------------------
function display_1(INPIMG)
% Displays a 2-D signal as an image 
% with normalization by gobal maximum and minimum
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il) 
% Call display_1(INPIMG)

colormap(gray(256))
Min=min(min(INPIMG)); Max=max(max(INPIMG));
if Max-Min==0, im=zeros(size(INPIMG)); else im=255*(INPIMG-Min)/(Max-Min); end

image(im);axis image;axis off;
%-------------------------------------------------------------------------------
function dspl=disp_norm(INPIMG,g)
% 2-D signal display with normalization by mean value and standard deviation
% g- is a parameter that defines ratio of the display range 0-255
% to the signal standard deviation 
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il) 
% Call disp_norm(INPIMG,g)

[SzX SzY]=size(INPIMG);
Mean=mean(mean(INPIMG));		
stdv=sqrt(mean(mean((INPIMG-Mean).^2)))+eps;
dspl=round(255*(INPIMG-Mean)/(g*stdv))+128;
dspl=(dspl>=0).*dspl;
dspl=(dspl<=255).*dspl+255*ones(SzX,SzY).*(dspl>255);
display_1(dspl);
%---------------------------------------------------
function OUTIMG=img_ext(INPIMG,Lx,Ly);

% Image extention by mirror reflection from its borders
% by Lx,Ly pixels from the corresponding sides
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUTIMG=img_ext(INPIMG,Lx,Ly);

[SzX,SzY]=size(INPIMG);

OUTIMG=[fliplr(INPIMG(:,1:Ly)),INPIMG,fliplr(INPIMG(:,SzY-Ly+1:SzY))];
OUTIMG=[flipud(OUTIMG(1:Lx,:));OUTIMG;flipud(OUTIMG(SzX-Lx+1:SzX,:))];
%-------------------------------------------------------------------------
function col_displ(R,G,B);
% Color display of RGB images
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Call col_displ(R,G,B)

mx=max(max([R,G,B]));
mn=min(min([R,G,B])); 
mxmn=mx-mn;
[X,map]=rgb2ind((R-mn)/mxmn,((G-mn)/mxmn),(B-mn)/mxmn,1024);
imshow(X,map);

imshow((R-mn)/mxmn,((G-mn)/mxmn),(B-mn)/mxmn,'notruesize')
%--------------------------------------------------------------------------
function OUTIMG=meanEV(INPIMG,Lx,Ly,evpos,evneg);

% MEAN over EV-neighborhood in the window LX*LY;
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call  OUTIMG=meanEV(INPIMG,LX,LY,evpos,evneg);


[SzX SzY]=size(INPIMG);
OUTIMG=INPIMG;

imgext=img_ext(INPIMG,Lx,Ly);

% LOCAL HISTOGRAM 

for X0=1:SzX,
%------------ FORMATION OF NEIGHBORHOOD MATRIX-------------------

	nbhood=zeros((2*Lx+1)*(2*Ly+1),SzY);
	Y=1:SzY;
	for y=-Ly:Ly,
        nbhood((2*Lx+1)*(Ly+y)+1:(2*Lx+1)*(Ly+y+1),Y)=imgext(X0:X0+2*Lx,Y+Ly+y);
	end
    centerpos=kron(INPIMG(X0,:)+evpos,ones((2*Lx+1)*(2*Ly+1),1));
    centerneg=kron(INPIMG(X0,:)-evneg,ones((2*Lx+1)*(2*Ly+1),1));
    evnbh=(nbhood<centerpos).*(nbhood>centerneg);
    sizeev=sum(evnbh);
    EVnbh=nbhood.*evnbh;

    OUTIMG(X0,:)=sum(EVnbh)./sizeev;
    if X0-16*fix(X0/16)==1,
        image(OUTIMG);axis image;axis off 
        title(['Output image, EVplus=',num2str(evpos),'; EVminus=',num2str(evneg)],'FontWeight','Bold');
	    drawnow;
    end

end

OUTIMG=round(OUTIMG);
%------------------------------------------------------------------------
function OUTIMG=modeES(INPIMG,Lx,Ly);

% MODE over window (2Lx+1)(2Ly+1)
% Displ - display flag; Output image is displayed in course of processing if Displ=1;
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUTIMG=mode_es(INPIMG,Lx,Ly);

LX=2*Lx+1;
LY=2*Ly+1;
[SzX SzY]=size(INPIMG);
OUTIMG=zeros(SzX,SzY);
imgext=img_ext(INPIMG,Lx,Ly);

histbuf=zeros(256,SzY+2*Ly);

%Column histograms for the first row
for n=1:2*Lx+1,
	buf=imgext(n,:); buf=buf+256*([0:SzY+2*Ly-1]);
	histbuf(buf+1)=histbuf(buf+1)+ones(1,SzY+2*Ly);
end

%FIRST HISTOGRAM IN THE FIRST ROW
	
h=sum(histbuf(:,1:2*Ly+1)')';
[Y,I]=max(h);
OUTIMG(1,1)=I;

% HISTOGRAMS FOR THE REST OF PIXELS IN THE ROW
for y=2:SzY,
	h=h-histbuf(:,y-1)+histbuf(:,y+LY-1);
   [Y,I]=max(h);
   OUTIMG(1,y)=I;
end

%COLUMN HISTOGRAMS FOR THE REST OF IMAGE

for x=2:SzX,
    title([num2str(x),'th row from ',num2str(SzX)],'FontWeight','Bold')
	buf=imgext(x-1,:); buf=buf+256*([0:SzY+2*Ly-1]);
	histbuf(buf+1)=histbuf(buf+1)-ones(1,SzY+2*Ly);
	buf=imgext(2*Lx+1+x-1,:); buf=buf+256*([0:SzY+2*Ly-1]);
	histbuf(buf+1)=histbuf(buf+1)+ones(1,SzY+2*Ly);

%FIRST HISTOGRAM IN THE Xth ROW
   h=sum(histbuf(:,1:2*Ly+1)')';
   [Y,I]=max(h);
	OUTIMG(x,1)=I;

%HISTOGRAMS FOR THE REST OF PIXELS IN THE Xth ROW			
	for y=2:SzY,
      h=h-histbuf(:,y-1)+histbuf(:,y+LY-1);
      [Y,I]=max(h);
      OUTIMG(x,y)=I-1;
	end
    image(OUTIMG);axis image;axis off
    title(['MODE_ES over the window ',num2str(LX),'x',num2str(LY)],'FontWeight','Bold');drawnow
end
display1(OUTIMG);
title(['MODE_EV over the window ',num2str(LX),'x',num2str(LY)],'FontWeight','Bold');
%--------------------------------------------------------------------------------------
function OUTIMG=max_mines(INPIMG,Lx,Ly);

% MAX&MIN over ES neighborhood in window (2Lx+1)(2Ly+1)
% OUTIMG=[MAX_ES,MIN_ES];
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call  OUTIMG=max_mines(INPIMG,Lx,Ly);

LX=2*Lx+1;
LY=2*Ly+1;

[SzX SzY]=size(INPIMG);
OUTIMGmax=INPIMG;
OUTIMGmin=INPIMG;
imgext=img_ext(INPIMG,Lx,Ly);
for X0=1:SzX,
	% FORMATION OF NEIGHBORHOOD MATRIX
	nbhood=zeros(LX*LY,SzY);
	Y=1:SzY;
	for y=-Ly:Ly,
        nbhood((2*Lx+1)*(Ly+y)+1:(2*Lx+1)*(Ly+y+1),Y)=imgext(X0:X0+2*Lx,Y+Ly+y);
	end

    OUTIMG(X0,:)=max(nbhood)-min(nbhood);
    if(X0/16)-fix(X0/16)==0
    imshow(OUTIMG,[]);axis image;axis off
    title(['MaxES-MinES; LX*LY=',num2str(LX),'*',num2str(LY)],'FontWeight','Bold');
    drawnow;
    end
end

%-----------------------------------------------------------------------------------------
function OUTIMG=sizeEV(INPIMG,Lx,Ly,evpos,evneg);

% Size of EV neighborhood over (2Lx+1)*(2)Ly+1) window
% evpos,evneg -boundaries of EV-neighborhood
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call  OUTIMG=sizeEV(INPIMG,Lx,Ly,evpos,evneg);


LX=2*Lx+1;
LY=2*Ly+1;

[SzX SzY]=size(INPIMG);
OUTIMG=zeros(SzX,SzY);
imgext=img_ext(INPIMG,Lx,Ly);
% LOCAL HISTOGRAM 

for X0=1:SzX,
	% FORMATION OF NEIGHBORHOOD MATRIX
	nbhood=zeros((2*Lx+1)*(2*Ly+1),SzY);
	Y=1:SzY;
	for y=-Ly:Ly,
		nbhood((2*Lx+1)*(Ly+y)+1:(2*Lx+1)*(Ly+y+1),Y)=imgext(X0:X0+2*Lx,Y+Ly+y);
	end
	centerpos=kron(INPIMG(X0,:)+evpos,ones((2*Lx+1)*(2*Ly+1),1));
	centerneg=kron(INPIMG(X0,:)-evneg,ones((2*Lx+1)*(2*Ly+1),1));
	evnbh=(nbhood<centerpos).*(nbhood>centerneg);

	OUTIMG(X0,:)=sum(evnbh);
    image(OUTIMG*255/max(OUTIMG(:)));axis image;axis off
    drawnow;
end
OUTIMG=OUTIMG*255/max(OUTIMG(:));
%-------------------------------------------------------
function OUTIMG=lc_cardinality(INPIMG,Lx,Ly);

% Pixel local cardinality in the window (2*Lx+1)(2*Ly+1)
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUTIMG=OUTIMG=lc_cardinality(INPIMG,Lx,Ly);


LX=2*Lx+1;
LY=2*Ly+1;
[SzX SzY]=size(INPIMG);
clf
OUTIMG=zeros(SzX,SzY);
imgext=img_ext(INPIMG,Lx,Ly);
histbuf=zeros(256,SzY+2*Ly);
%Column histograms for the first row
for n=1:2*Lx+1,
	buf=imgext(n,:); buf=buf+256*([0:SzY+2*Ly-1]);
	histbuf(buf+1)=histbuf(buf+1)+ones(1,SzY+2*Ly);
end
%FIRST HISTOGRAM IN THE FIRST ROW	
h=sum(histbuf(:,1:2*Ly+1)')';frgmhist=h;
OUTIMG(1,1)=h(INPIMG(1,1)+1);
% HISTOGRAMS FOR THE REST OF PIXELS IN THE ROW
for y=2:SzY,
	frgmhist=h;
	h=h-histbuf(:,y-1)+histbuf(:,y+LY-1);
	OUTIMG(1,y)=h(INPIMG(1,y)+1);
end
%COLUMN HISTOGRAMS FOR THE REST OF IMAGE
for x=2:SzX,
	buf=imgext(x-1,:); buf=buf+256*([0:SzY+2*Ly-1]);
	histbuf(buf+1)=histbuf(buf+1)-ones(1,SzY+2*Ly);
	buf=imgext(2*Lx+1+x-1,:); buf=buf+256*([0:SzY+2*Ly-1]);
	histbuf(buf+1)=histbuf(buf+1)+ones(1,SzY+2*Ly);
%FIRST HISTOGRAM IN THE Xth ROW
	h=sum(histbuf(:,1:2*Ly+1)')';
	frgmhist=h;
	OUTIMG(x,1)=h(INPIMG(x,1)+1);
%HISTOGRAMS FOR THE REST OF PIXELS IN THE Xth ROW			
	for y=2:SzY,
	frgmhist=h;
	h=h-histbuf(:,y-1)+histbuf(:,y+LY-1);
	OUTIMG(x,y)=h(INPIMG(x,y)+1);
	end
	if x/16-fix(x/16)==1/16,
   	display1(OUTIMG);
   	title('Pixel local cardinality');drawnow
    end
end
% display1(OUTIMG);
% title('Pixel local cardinality');drawnow

OUTIMG=uquan256(OUTIMG);
%--------------------------------------------------------------
function OUTMEDN=loc_medn(INPIMG,LX,LY);

%**************************************************************
% Local median filtering over window; 
% LX - is window vertical size;
% LY - is window horizontal size;
% Image mirror extention by the size of the spatial window
% Copyright: L. Yaroslavsky (yaro@eng.tau.ac.il); modified lc_medn 30.01.2012 
% Call: OUTMEDN=loc_medn(INPIMG,LX,LY)
%**************************************************************

Lx=(LX-1)/2;
Ly=(LY-1)/2;
[SzX SzY]=size(INPIMG);
OUTMEDN=INPIMG;
Imgext=imgext(INPIMG,Lx,Ly);
h=waitbar(0,'Filtering in progress');
for X=1:SzX,
    waitbar(X/SzX,h)
	% Neighbourhood matrix
	nbhood=zeros(LX*LY,SzY);
   Y=1:SzY;
	for y=-Ly:Ly,
      nbhood(LX*(Ly+y)+1:LX*(Ly+y+1),Y)=Imgext(X:X+2*Lx,Y+Ly+y);
    end
   OUTMEDN(X,:)=median(nbhood);
end
close(h);
stdmedn=std2d(INPIMG-OUTMEDN);

%-------------------------------------------------------
function OUTIMG=uquan256(INPIMG);

% Uniform quantization of a signal into a range [0-255];
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUTIMG=uquan256(INPIMG);

mn=min(min(INPIMG));
mx=max(max(INPIMG));
 
OUTIMG=round(255*(INPIMG-mn)/(mx-mn));